<template>
	<div class="row">
		<div class="col-4">
			<label for="tipo" class="form-label">Tipo</label>
			<select
				class="form-select form-select-sm"
				v-model="form.tipo"
				:disabled="disabled"
			>
				<option v-for="elem in tiposDoc" :value="elem" :key="elem.tipo_doc">
					{{ elem.descripcion }}
				</option>
			</select>
		</div>
		<div class="col-8">
			<label for="num-documento" class="form-label">N° de Documento</label>
			<input
				id="num-documento"
				type="text"
				class="form-control form-control-sm"
				:placeholder="
					typeof form.tipo !== 'undefined' ? '' : 'Indique un tipo de documento'
				"
				:disabled="typeof form.tipo === 'undefined' || disabled"
				v-model.trim="form.numero"
			/>
		</div>
	</div>
</template>

<script lang="ts">
// Libraries
import { defineComponent } from "vue";
import http from "@/http";
import shared from "@/shared.js";
import Swal from "sweetalert2/dist/sweetalert2.js";

// Store
import { mapState } from "pinia";
import { useAuxFormDataStore } from "@/stores/auxFormData";

// Entities
import type { TipoDoc } from "@/entities/TipoDoc";
import { Persona } from "@/entities/Persona";

const { urlApi, loading } = shared();

export default defineComponent({
	name: "BusquedaDocumento",
	props: ["modelValue", "disabled"],
	emits: ["update:modelValue"],
	data() {
		return {
			form: {
				tipo: undefined as TipoDoc | undefined,
				numero: "" as string,
			},
			init: true as boolean, // Permite que no se ejecute la busqueda al inicializar el componente con un valor
			timer: 0 as number,
		};
	},
	computed: {
		documento(): string | undefined {
			if (
				typeof this.form.tipo !== "undefined" &&
				typeof this.form.tipo.tipo_doc !== "undefined" &&
				this.form.numero.length >= 6
			) {
				return this.form.tipo.tipo_doc + "" + this.form.numero;
			}
			return undefined;
		},
		...mapState(useAuxFormDataStore, ["tiposDoc"]),
		isSearchEnable(): boolean {
			return !this.init || typeof this.modelValue == "undefined";
		},
	},
	methods: {
		async search(campo_busq: string | undefined = undefined) {
			var persona = undefined as Persona | undefined;
			// var persona = this.modelValue as Persona | undefined;
			//if (typeof campo_busq !== "undefined" && typeof persona === "undefined") { luis
			if (typeof campo_busq !== "undefined") {
				loading.show();
				try {
					var rta = await http.get(urlApi + "intraBusqueda", {
						params: {
							tipo_busq: "D",
							campo_busq: campo_busq,
							busca_en_his: "S",
						},
					});

					if (rta.data.status == "success") {
						var data: any = rta.data.res;
						persona = new Persona(
							data.tipo_doc,
							data.nro_doc,
							data.calle_legal,
							data.nro_legal,
							data.piso_legal,
							data.dto_legal,
							data.loc_legal,
							data.cp_legal,
							data.pcia_legal,
							data.nombres,
							data.apellido,
							data.nro_id_trib
						);
					} else {
						persona = undefined;
					}
				} catch (error) {
					Swal.fire({
						icon: "error",
						text: "Ocurrio un error al cargar datos de la persona",
					});
				} finally {
					loading.hide();
				}
			}
			this.$emit("update:modelValue", persona);
		},
		async modelValueInit() {},
	},
	watch: {
		documento(newValue: string) {
			clearTimeout(this.timer);
			if (this.isSearchEnable) {
				this.timer = setTimeout(async () => {
					await this.search(newValue);
				}, 500);
			}
			this.init = false;
		},
		async modelValue() {
			if (typeof this.modelValue !== "undefined") {
				this.form.tipo = this.tiposDoc.find((obj) => {
					return obj.tipo_doc.toString() == this.modelValue.tipo_doc;
				});
				this.form.numero = this.modelValue.nro_doc;
			}
			// else {
			// 	this.form.tipo = undefined;
			// 	this.form.numero = "";
			// }
		},
	},
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
